// LseDoc.cpp : implementation of the CLseDoc class
//

#include "stdafx.h"
#include "Lse.h"

#include "LseDoc.h"
#include "LseView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLseDoc

IMPLEMENT_DYNCREATE(CLseDoc, CDocument)

BEGIN_MESSAGE_MAP(CLseDoc, CDocument)
	//{{AFX_MSG_MAP(CLseDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_DETAILS, OnUpdateDetails)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLseDoc construction/destruction

CLseDoc::CLseDoc()
{
	m_pszDescription = "New L-System";
}

CLseDoc::~CLseDoc()
{
}

BOOL CLseDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	m_pszDescription = "New L-System";
	SetTitle(m_pszDescription);
	GetLseView()->NewFile();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CLseDoc serialization

void CLseDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CLseDoc diagnostics

#ifdef _DEBUG
void CLseDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CLseDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CLseDoc commands

BOOL CLseDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
		
	GetLseView()->LoadFile(lpszPathName);
	
	return TRUE;
}

void CLseDoc::SetDescription(CString desc)
{
	m_pszDescription = desc;
}

void CLseDoc::SetTitle(LPCTSTR lpszTitle) 
{	
	CDocument::SetTitle(m_pszDescription);
}

BOOL CLseDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	return GetLseView()->SaveFile(lpszPathName);
}

CLseView *CLseDoc::GetLseView()
{
	POSITION pos = GetFirstViewPosition();

	CView* pView = GetNextView(pos);

	return reinterpret_cast<CLseView *>(pView);
}

void CLseDoc::OnUpdateDetails(CCmdUI *pCmdUI)
{
	int d,s;
	CString str;
	GetLseView()->GetDepthAndSegment(d, s);
	str.Format(" Dph %d, Seg %d", d, s);

    pCmdUI->Enable();
	pCmdUI->SetText(str);
}

