// LseView.h : interface of the CLseView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_LSEVIEW_H__2BF229CC_4C6B_11D5_8876_444553540000__INCLUDED_)
#define AFX_LSEVIEW_H__2BF229CC_4C6B_11D5_8876_444553540000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define LSYS_STACK_SIZE		100
#define LSE_MAXDEPTH		48

typedef struct {
	float	angle;
	int		pos_x;
	int		pos_y;
} _lstate;

class CLseView : public CView
{
protected: // create from serialization only
	CLseView();
	DECLARE_DYNCREATE(CLseView)

// Attributes
public:
	CLseDoc* GetDocument();

	bool	LoadFile(CString);
	bool	SaveFile(CString);

	void	GetDepthAndSegment(int &d, int &s) { d = m_iMaxDepth, s = m_iSegment; }

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLseView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	//}}AFX_VIRTUAL

// Implementation
public:
	void NewFile();
	virtual ~CLseView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	bool	m_bMouseWheel;
	bool	m_bPropOnLoad;
	bool	m_bMouseDragging;
	float	m_fAngle;
	float	m_fStepSize;
	float	m_fInitAngle;
	int		m_iSegment;
	int		m_iMaxDepth;
	int		m_iMouseDepth;
	int		m_iSP;
	int		m_iPenIndex;
	int		m_iSegments;

	BOOL	m_bCalculating;
	double	m_dr, m_dg, m_db;
	double	m_dcr, m_dcg, m_dcb;

	CString	m_pszName;

	_lstate	m_sStack[LSYS_STACK_SIZE];

	COLORREF	m_crLine;
	COLORREF	m_crBackground;

	COLORREF	m_crStart;
	COLORREF	m_crEnd;

	CPoint	m_cStartPoint;
	CPoint	m_cDragPoint;
	CString	m_pszAxiom;
	CString	m_pszRules[26];

	bool	PushState(float, int, int);

	void	DrawLSystems(CString, CDC*, float, int);
	void	PopState(float &, CPoint &);

	CString	Rule(char c) { return m_pszRules[c - 'A']; }

	inline int	 Round(double);
	inline float Decrement(float, float);
	inline float Increment(float, float);

protected:
	void CalculateInfo();
	void GenerateGradient(int);
	void InitRulesArray();
	//{{AFX_MSG(CLseView)
	afx_msg void OnEditLsystem();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnViewOptions();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnEditDecreaseDepth();
	afx_msg void OnEditIncreaseDepth();
	afx_msg void OnEditCopy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in LseView.cpp
inline CLseDoc* CLseView::GetDocument()
   { return (CLseDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LSEVIEW_H__2BF229CC_4C6B_11D5_8876_444553540000__INCLUDED_)
